/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    choice.c inneh}ller funktioner f|r urval av filer
*************************************************************************/

#include <stdio.h>
#include "fsadm.h"
#include "struct.h"

/* Meddelanden och menyval */
extern int n_lang;
extern int lang;

/* Terminalparametrar */
extern int term;
extern char *cm;

extern char cwd[];

extern struct viewport port[];
extern int port_h;
extern int p_port_h, p_port_w;

/*** Fr}ga efter ett m|nster och m{rk alla filer som matchar m|nstret ***/
choice()
{
    register struct file_info *filep, *prevp;
    char pattern[15];

    ask(PATTERN, NULL, pattern, 15);
    if (*pattern == '\0')
	return;
    for (filep = port[FILES].first; filep; filep = filep->next)
	/* Kolla filen mot m|nstret */
	if (match(filep->name, pattern)) {
	    /* Kolla om filen redan fanns i poolen */
	    for (prevp = port[POOL].filelist; prevp; prevp = prevp->next)
		if (strcmp(filep->path, prevp->path) == 0)
		    break;
	    if (prevp == NULL)
		/* L{gg in filen i poolen */
		insert(POOL, cwd, filep->name);
	    }
    pr_port(POOL);
}

/*** Matcha ett filnamn mot ett m|nster ***/
match(name, patt)
register char *name, *patt;
{
    register char *p;

    while (*patt) {
	switch (*patt) {
	    case '?':
		break;
	    case '*':
		if (*(patt + 1) == '\0')
		    return (TRUE);
		for (p = name; *p; p++)
		    if (match(p, patt + 1))
			return (TRUE);
		return (FALSE);
	    default:
		if (*name != *patt)
		    return (FALSE);
	    }
	patt++;
	name++;
	}
    return (NOT *name);
}
