/*************\
* 	      *
* the window  *
* 	      *
\*************/

#define WR 24  /* size of the window */
#define WC 80

#define NL 2  /* number of languages supported */

#define FW 9  /* size of the font box */
#define FH 14


/***************\
* 	        *
* the viewport  *
* 	        *
\***************/

typedef struct viewport {
  short x, y, off, cnt, max;
  char **path, **name;
  char *header[NL];
};
extern struct viewport port[];

#define NR 18  /* size of the viewport */
#define NC 14  /* should be same as DIRSIZ */
#define PW FW*NC  /* in pixels */
#define PH FH*NR

#define PX port[pt].x  /* origo of port v */
#define PY port[pt].y

#define FILES 0  /* indicies to the viewports */
#define DIRS 1
#define POOL 2


/****************\
* 		 *
* the click box	 *
* 		 *
\****************/

typedef struct click_box {
  char *txt;
  int (*func)();
  short chk;
};
extern struct click_box kikon[];
extern struct click_box fikon[];

#define BKN 9  /* number of command boxes */
#define BFN 2  /* number of function boxes */

#define BW 10*FW
#define BH 3*FH/2
#define BD 2*FH

#define BKX 68*FW  /* origo of command boxes */
#define BKY BD

#define BFX 38*FW  /* origo of function boxes */
#define BFY 6*FH


/****************\
* 	         *
* miscellaneous  *
* 	         *
\****************/

extern char cwd[];  /* current working directory */

#define BELL write(STDERR, '\007')

#ifndef ON
#define ON 1
#endif
#ifndef OFF
#define OFF 0
#endif
#ifndef NULL
#define NULL 0
#endif

#define STDIN 0
#define STDOUT 1
#define STDERR 2
