#include "fsadm.h"
#define CLS(a, b) p += sprintf(p, "\033:0;0m\033:%d;%df", a, b)
#define MOVE(a, b) p += sprintf(p, "\033:%d;%dm", a, b)
#define CUR(a, b, c) p += sprintf(p, "\033:%d;%dm\033:1H%s", a, b, c)
#define LINE(a, b) p += sprintf(p, "\033:%d;%d;;1d", a, b)
#define FILL(a, b, c) p += sprintf(p, "\033:%d;%d;1f", a, b)
#define COPY(sx, sy, dx, dy, w, h, o) p += sprintf(p,\
	"\033:%d;%d;%d;%d;%d;%d;%dr",\
	sx, sy, dx, dy, w, h, o)

static char grbuf[1300];
static short grsiz;
extern short language;
extern short mode;


mkport()
{
  register short pt, i;
  short dx, dy;
  register char *p;

  p = grbuf;
  pt = FILES;

  /* clear screen */
  CLS(WC*FW-1, WR*FH-1);

  /* draw port box */
  MOVE(PX, PY);
  LINE(PX+PW+19, PY);
  LINE(PX+PW+19, PY+PH+FH+2);
  LINE(PX, PY+PH+FH+2);
  LINE(PX, PY);
  MOVE(PX, PY+PH+1);
  LINE(PX+PW+19, PY+PH+1);
  MOVE(PX+PW+1, PY);
  LINE(PX+PW+1, PY+PH+1);
  MOVE(PX+PW+1, PY+PH-25);
  LINE(PX+PW+19, PY+PH-25);
  MOVE(PX+PW+1, PY+26);
  LINE(PX+PW+19, PY+26);

  /* arrow up */
  MOVE(PX+PW+8, PY+PH-20);
  LINE(PX+PW+8, PY+PH-11);
  LINE(PX+PW+4, PY+PH-11);
  LINE(PX+PW+10, PY+PH-5);
  LINE(PX+PW+16, PY+PH-11);
  LINE(PX+PW+12, PY+PH-11);
  LINE(PX+PW+12, PY+PH-20);
  LINE(PX+PW+8, PY+PH-20);

  /* arrow down */
  MOVE(PX+PW+12, PY+20);
  LINE(PX+PW+12, PY+11);
  LINE(PX+PW+16, PY+11);
  LINE(PX+PW+10, PY+5);
  LINE(PX+PW+4, PY+11);
  LINE(PX+PW+8, PY+11);
  LINE(PX+PW+8, PY+20);
  LINE(PX+PW+12, PY+20);

  MOVE(PX+1, PY+PH+2);
  FILL(PX+PW+18, PY+PH+FH+1, 1);

  /* copy port */
  COPY(PX, PY, port[DIRS].x, port[DIRS].y, PW+20, PH+FH+11, 0);
  COPY(PX, PY, port[POOL].x, port[POOL].y, PW+20, PH+FH+11, 0);

  /* port headers */
  for (pt = 0; pt < 3; pt++) {
    dx = strlen(port[pt].header[language]) * FW;
    CUR(PX + (PW+20-dx) / 2, PY+PH+2, port[pt].header[language]);
  }

  /* click-box */
  MOVE(BKX+5, BKY);
  LINE(BKX+BW-6, BKY); LINE(BKX+BW-1, BKY+5);
  LINE(BKX+BW-1, BKY+BH-6); LINE(BKX+BW-6, BKY+BH-1);
  LINE(BKX+5, BKY+BH-1); LINE(BKX, BKY+BH-6);
  LINE(BKX, BKY+5); LINE(BKX+5, BKY);
  for (i = 1; i < BKN; i++) {
    COPY(BKX, BKY, BKX, BKY + i*BD, BW, BH, 0);
  }
  for (i = 0; i < BKN; i++) {
    dx = (BW - strlen(kikon[i].txt)*FW) / 2;
    dy = (BH - FH) / 2;
    CUR(BKX + dx, BKY + i*BD + dy, kikon[i].txt);
  }

  /* mode boxes */
  dy = (BH - FH) / 2;
  for (i = 0; i < BFN; i++) {
    dx = (BW - strlen(fikon[i].txt)*FW) / 2;
    CUR(BFX + dx, BFY + i*BD + dy, fikon[i].txt);
    MOVE(BFX, BFY + i*BD);
    LINE(BFX + BW - 1, BFY + i*BD);
    LINE(BFX + BW - 1, BFY + i*BD + BH - 1);
    LINE(BFX, BFY + i*BD + BH - 1);
    LINE(BFX, BFY + i*BD);
  }

  /* cwd frame */
  MOVE(0, WR*FH-BH);
  LINE(WC*FW-1, WR*FH-BH);
  LINE(WC*FW-1, WR*FH-1);
  LINE(0, WR*FH-1);
  LINE(0, WR*FH-BH);

  /* version */
  dx = (BW - strlen("FSADM")*FW) / 2;
  CUR(BFX + dx, BFY + (BFN+4)*BD + dy, "FSADM");
  dx = (BW - strlen("Ver. 1.0")*FW) / 2;
  CUR(BFX + dx, BFY + (BFN+3)*BD + dy, "Ver. 1.0");

  grsiz = p - grbuf;

/* *** trace size of grbuf *** */
print("%d/%d", grsiz, sizeof(grbuf));
flush(STDOUT);
}

draw()
{
  refresh(OFF);
  write(STDOUT, grbuf, grsiz);
  mark(mode);
  printpath();
  printport(FILES);
  printport(DIRS);
  printport(POOL);
  refresh(ON);
}
