#include "fsadm.h"

short mode = BFN-1;

scan()
{
  register int c;
  register short p1, p2;

  do {
    if (getch(ON) == '\033') {
      c = getch(ON);
      p1 = getint();
      switch (c) {
        case 'F':
          do_func(p1);
          break;
        case 'P':
          p2 = getint();
          do_port(p1, p2);
          break;
        case 'S':
          p2 = getint();
          if (p2) scrolldn(p1);
          else scrollup(p1);
          break;
        case 'M':
          (*fikon[p1].func)(p1);
          break;
        default:
          BELL;
          break;
      }
    }
    else BELL;
  } while (1);
}

getint()
{
  register int c, s;

  for (s = 0; c = getch(ON), '0' <= c && c <= '9'; s = 10*s + c - '0');
  return(s);
}

do_func(funcno)
register short funcno;
{
  if (kikon[funcno].chk && !port[POOL].cnt) {
    message(2);
    return;
  }
  (*kikon[funcno].func)();
  if (kikon[funcno].chk) {
    reset(POOL);
    printport(POOL);
  }
}

do_port(pt, off)
register short pt, off;
{
  register short ix;

  if ((ix = off + port[pt].off) >= port[pt].cnt) {
    BELL;
    return;
  }
  if (pt == POOL) sub_fr_port(POOL, ix);
  else {
    switch (mode) {
      case 0:
        if (pt == DIRS) cd(port[DIRS].name[ix]);
        else BELL;
        break;
      case 1:
        if (!strcmp(port[pt].name[ix], ".") ||
            !strcmp(port[pt].name[ix],"..")) {
          message(20, port[pt].name[ix]);
        }
        else add_to_port(POOL, port[pt].name[ix]);
        break;
    }
  }
}

set_mode(m)
register short m;
{
  if (m != mode) {
    mark(m);
    mark(mode);
    mode = m;
  }
}

mark(m)
register short m;
{
  register short xl, xh, yl, yh;

  xl = BFX - 2;
  xh = BFX + BW + 1;
  yl = BFY + m*BD - 2;
  yh = BFY + m*BD + BH + 1;
  print("\033:%d;%dm", xl, yl);
  print("\033:%d;%di", xh, yl);
  print("\033:%d;%di", xh, yh);
  print("\033:%d;%di", xl, yh);
  print("\033:%d;%di", xl, yl);
  flush(STDOUT);
}

printpath()
{
  print("\033:1;%dm\033:%d;%df", WR*FH-BH+1, WC*FW-2, WR*FH-2);
  print("\033:4;%dm\033:1H%s", WR*FH-BH+3, cwd);
  flush(STDOUT);
}

cd(dn)
register char *dn;
{
  register char nwd[WC], *p;
  char *strrchr();

  if (strcmp(dn, ".")) {
    strcpy(nwd, cwd);
    if (!strcmp(dn, "..")) {
      if ((p = strrchr(nwd, '/')) == nwd) {
        message(5);
        return;
      }
      *p = '\0';
      p = strrchr(nwd, '/');
      *++p = '\0';
    }
    else {
      if (strlen(cwd)+strlen(dn) > WC) panic("To long pathname in cwd");
      strcat(strcat(nwd, dn), "/");
    }
    if (chdir(nwd) == -1) {
      message(7);
      return;
    }
    strcpy(cwd, nwd);
    printpath();
  }
  readdir();
  printport(FILES);
  printport(DIRS);
}
