#include "fsadm.h"
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <fcntl.h>


short getftype(ix)
register short ix;
{
  struct stat stbuf;

  if (stat(port[POOL].path[ix], &stbuf) == -1) return(-1);
  return(S_ISDIR(stbuf.st_mode));
}

short getfmode(ix)
register short ix;
{
  struct stat stbuf;

  if (stat(port[POOL].path[ix], &stbuf) == -1) return(-1);
  if (stbuf.st_uid != getuid()) return(-1);
  return(stbuf.st_mode & 0777);
}

readdir()
{
  struct direct dirbuf;
  struct stat stbuf;
  register int fd, i;
  char nbuf[NC+1];
  short insert();

  reset(FILES);
  reset(DIRS);
  if ((fd = open(".", O_RDONLY)) == -1) panic("Can't open .");
  while (read(fd, (char *) &dirbuf, sizeof(dirbuf)) > 0) {
    if (dirbuf.d_ino == 0) continue;
    for (i = 0; i < NC; i++) nbuf[i] = dirbuf.d_name[i];
    nbuf[NC] = '\0';
    if (stat(nbuf, &stbuf) == -1) panic("Can't get status for %s", nbuf);
    insert(S_ISDIR(stbuf.st_mode) ? DIRS : FILES, cwd, nbuf);
  }
  close(fd);
}

printport(pt)
register short pt;
{
  register short i;

  print("\033:%d;%dm\033:%d;%df", PX+1, PY+1, PX+PW, PY+PH);
  for (i = 0; i < NR && (port[pt].off + i) < port[pt].cnt; i++) {
    print("\033:%d;%dm\033:0H%s",
           PX+1, PY+(NR-i)*FH, port[pt].name[port[pt].off+i]);
  }
  bars(pt);
  flush(STDOUT);
}

add_to_port(pt, fn)
register short pt;
register char *fn;
{
  register short offset;

  offset = insert(pt, cwd, fn) - port[pt].off;
  if (offset < 0) port[pt].off++;
  else if (offset < NR) {  /* visible */
    expand(pt, offset);
    print("\033:1H%s", fn);
  }
  bars(pt);
  flush(STDOUT);
}

sub_fr_port(pt, ix)
register short pt, ix;
{
  register short offset;

  extract(pt, ix);
  offset = ix - port[pt].off;
  if (offset < 0) port[pt].off--;
  else if (offset < NR) {
    if (port[pt].off + NR <= port[pt].cnt) {
      moveup(pt, offset);
      print("\033:1H%s", port[pt].name[port[pt].off + NR]);
    }
    else if (port[pt].off > 0) {
      port[pt].off--;
      movedn(pt, offset);
      print("\033:1H%s", port[pt].name[port[pt].off]);
    }
    else moveup(pt, offset);
  }
  bars(pt);
  flush(STDOUT);
}

scrollup(pt)
register short pt;
{
  register short n;

  if ((n = port[pt].cnt - port[pt].off - NR) > 0) {
    do {
      port[pt].off++;
      moveup(pt, 0);
      print("\033:1H%s", port[pt].name[port[pt].off+NR-1]);
      bars(pt);
      flush(STDOUT);
    } while (--n && button());
  }
  else BELL;
}

scrolldn(pt)
register short pt;
{
  register short n;

  if ((n = port[pt].off) > 0) {
    do {
      port[pt].off--;
      movedn(pt, NR-1);
      print("\033:1H%s", port[pt].name[port[pt].off]);
      bars(pt);
      flush(STDOUT);
    } while (--n && button());
  }
  else BELL;
}
